package service

import (
	"context"

	"xbus.io/go-xbus/v3"
	"xbus.io/go-xbus/v3/api"
	"xbus.io/go-xbus/v3/envelope"
)

type realOutputs struct {
	ctx   context.Context
	actor *xbus.Actor

	processingContext api.ProcessingContext
}

func (ro realOutputs) Forward(output string, id api.UUID) error {
	newEnv := api.Envelope{
		ID:   id,
		Last: true,
	}
	_, err := ro.actor.SendEnvelope(
		&ro.processingContext,
		output,
		newEnv)
	return err
}

func (ro realOutputs) Send(output string, env envelope.Envelope) error {
	return xbus.SendEnvelope(
		ro.ctx, env,
		api.EnvelopeMaxSize/3, xbus.EnvelopeSenderDefaultDelay, xbus.DefaultMaxChunksByFragment,
		func(fragment *api.Envelope) (api.EnvelopeAck_ReceptionStatus, error) {
			return ro.actor.SendEnvelope(&ro.processingContext, output, *fragment)
		})
}
